// lib/src/models/category_model.dart

class CategoryModel {
  int id;
  int? version;
  String clave;
  String nombre;
  int? fechaCreado;
  String categoria;
  bool? activo;

  CategoryModel({
    required this.id,
    this.version,
    required this.clave,
    required this.nombre,
    this.fechaCreado,
    required this.categoria,
    this.activo,
  });

  // Método para crear una instancia de CategoryModel desde un JSON
  factory CategoryModel.fromJson(Map<String, dynamic> json) => CategoryModel(
    id: json['id'],
    version: json['version'] ?? 0,
    clave: json['clave'] ?? '',
    nombre: json['nombre'] ?? '',
    fechaCreado: json['fechaCreado'],
    categoria: json['categoria'] ?? '',
    activo: json['activo'],
  );

  // Método para convertir una instancia de CategoryModel a JSON
  Map<String, dynamic> toJson() => {
    'id': id,
    'version': version,
    'clave': clave,
    'nombre': nombre,
    'fechaCreado': fechaCreado,
    'categoria': categoria,
    'activo': activo,
  };

  // Método para crear una lista de CategoryModel desde una lista de JSONs
  static List<CategoryModel> fromJsonArray(List<dynamic> json) {
    return json.map((data) => CategoryModel.fromJson(data)).toList();
  }

  // Método para convertir una lista de CategoryModel a una lista de JSONs
  static List<Map<String, dynamic>> toJsonArray(List<CategoryModel> list) {
    return list.map((item) => item.toJson()).toList();
  }
}
